#include <util/delay.h>
#include <avr/io.h>

#define LCDDATAPORT			PORTD
#define LCDDATADDR			DDRD
#define LCDDATAPIN			PIND
#define LCD_D4				0
#define LCD_D5				1
#define LCD_D6				2
#define LCD_D7				3

#define LCDCONTROLPORT		PORTD
#define LCDCONTROLDDR		DDRD
#define LCD_RS				5
#define LCD_RW				4
#define LCD_E				6

#define LCD_CONTROL_MASK ((1 << LCD_RS) | (1 << LCD_RW) | (1 << LCD_E))
#define LCD_DATA_MASK ((1 << LCD_D4) | (1 << LCD_D5) | (1 << LCD_D6) | (1 << LCD_D7))

#define LCD_STROBEDELAY_US	5

#define LCD_COMMAND			0
#define LCD_DATA			1

#define LCD_CURSOR_OFF		0
#define LCD_CURSOR_ON		2
#define LCD_CURSOR_BLINK	3

#define LCD_DISPLAY_OFF		0
#define LCD_DISPLAY_ON		4

#define LCD_SCROLL_LEFT		0
#define LCD_SCROLL_RIGHT	4

#define LCD_ROW1_OFFSET		0x00
#define LCD_ROW2_OFFSET		0x40
#define LCD_ROW3_OFFSET		0x10
#define LCD_ROW4_OFFSET		0x50

#define lcdEnableRussian

char lcdRawGetByte (char state);
void lcdRawSendByte (char byte, char state);
char lcdIsBusy (void);
void lcdInit (void);
void lcdSetCursor (char cursor);
void lcdSetDisplay (char state);
void lcdClear (void);
void lcdGotoXY (char str, char col);
void lcdDisplayScroll (char pos, char dir);
void lcdPutsFromRAM (char *str);
void lcdPutsFromFlash (char *str);
void lcdLoadCharacterFromRAM (char code, char *pattern);
void lcdLoadCharacterFromFlash (char code, char *pattern);

#ifdef lcdEnableRussian
	char toRussian (char byte);
#endif
